// ##########################################################################
// ####                                                                  ####
// ####                         Prfungsamt-Client                       ####
// ####                    ============================                  ####
// ####                                                                  ####
// #### Prfungsamt-Client                                               ####
// ####                                                                  ####
// #### Version 1.00  --  12. Juli 2000                                  ####
// ####                                                                  ####
// #### Copyright (C) 2000  Thomas Dreibholz                             ####
// ####                     Universitt Bonn                             ####
// ####                     EMail: Dreibholz@bigfoot.com                 ####
// ####                     WWW:   http://www.bigfoot.com/~dreibholz     ####
// ####                                                                  ####
// ##########################################################################


#ifndef PA_CLIENT_H
#define PA_CLIENT_H


#include "system.h"
#include "sqlconnectioninterface.h"
#include "textmonitor.h"


#include <qapp.h>
#if QT_VERSION < 210
#error ERROR: QT Version 2.1 or better required!!!
#endif
#include <qmainwindow.h>


/**
  * PAClient ist ein Qt-Widget fr das Hauptfenster des Prfungsamt-Clients.
  *
  * @short   PAClient
  * @author  Thomas Dreibholz (Dreibholz@bigfoot.com)
  * @version 1.0
  */
class PAClient : public QMainWindow
{
   Q_OBJECT

   // ====== Constructor/Destructor =========================================
   public:
   /**
     * Constructor.
     *
     * @param connection Datenbank-Verbindung.
     * @param monitor SQL-Monitor.
     * @param parent Parent QWidget; default: NULL.
     * @param name Widget-Name; default: NULL.
     */
   PAClient(SQLConnectionInterface* connection,
            TextMonitor*            monitor = NULL,
            QWidget*                parent  = NULL,
            const char*             name    = NULL);

   /**
     * Destructor.
     */
   ~PAClient();


   // ====== Slots fr Qt ===================================================
   public slots:
   /**
     * Qt-Slot: Informationsfenster anzeigen.
     */
   void information();

   /**
     * Qt-Slot: Beenden.
     */
   void quit();

   /**
     * Qt-Slot: Optimieren.
     */
   void optimize();

   /**
     * Qt-Slot: SQL-Monitor ffnen.
     */
   void openMonitor();

   /**
     * Qt-Slot: SQL-Monitor schlieen.
     */
   void closeMonitor();


   // ====== Private Daten ==================================================
   private:
   SQLConnectionInterface* Connection;
   TextMonitor*            Monitor;
};


#endif
