-- ##########################################################################
-- #### Anzahl Prfer/Studenten-Statistik                                ####
-- ##########################################################################


-- ====== Anzahl immatrikulierter Studenten =================================
DROP FUNCTION stat_studenten_anzahl();
CREATE FUNCTION stat_studenten_anzahl() RETURNS INTEGER AS '
   DECLARE
      anzahl INTEGER;
   BEGIN
      SELECT INTO anzahl COUNT(s.stud_id)
         FROM pers_studenten s
         WHERE s.exmat_datum IS NULL;
      RETURN anzahl;
   END;
' LANGUAGE 'plpgsql';


-- ====== Anzahl der nicht-pensionierten Prfer =============================
DROP FUNCTION stat_pruefer_anzahl();
CREATE FUNCTION stat_pruefer_anzahl() RETURNS INTEGER AS '
   DECLARE
      anzahl INTEGER;
   BEGIN
      SELECT INTO anzahl COUNT(p.pers_id)
         FROM pers_pruefer p
         WHERE p.pensionierung_datum IS NULL;
      RETURN anzahl;
   END;
' LANGUAGE 'plpgsql';


-- ====== Anzahl Prfer/Studenten-Statistik =================================
DROP VIEW stat_anzahl;
CREATE VIEW stat_anzahl AS
   SELECT NOW()                   AS Heute,
          stat_studenten_anzahl() AS Studenten,
          stat_pruefer_anzahl()   AS Pruefer;




SET DATESTYLE = GERMAN;
SELECT * from stat_anzahl;
